/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


////////////////////////////////////////////////////////////////////////////////////////////////////////

void clr_interface(void)
{
	ScrRectFill(&(SCR_RECT){{0, 0, 61, 99}}, &ECRAN, 0) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void ClrTerrain(void)
{
	asm ("
	lea		0x4C44.w,%%a1
	move.w	#123,%%d0
clr_terrain:
	clr.l	(%%a1)+ ; clr.l	(%%a1)+ ; clr.l	(%%a1)+ ; clr.l	(%%a1)+ ; clr.l	(%%a1)
	lea		(14,%%a1),%%a1
	dbra	%%d0,clr_terrain
	" ::: "d0","a1") ;

	Boucle() ;

	#ifdef _92
		if (TailleTerrain == NORMAL)
			DrawLine(161, 0, 161, 99, 4) ;
		else
			DrawLine(225, 0, 225, 127, 4) ;
	#endif
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void SavTerrain(char *tampon)
{
	asm ("
	lea		0x4C44.w,%%a1
	move.w	#123,%%d0
sav_terrain:
	move.l	(%%a1)+,(%0)+ ; move.l  (%%a1)+,(%0)+ ; move.l  (%%a1)+,(%0)+ ; move.l  (%%a1)+,(%0)+ ; move.l  (%%a1),(%0)+
	lea		(14,%%a1),%%a1
	dbra	%%d0,sav_terrain
	" :: "a" (tampon): "d0","a1") ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void RestaureTerrain(char *tampon)
{
	asm ("
	lea		0x4C44.w,%%a1
	move.w	#123,%%d0
restaure_terrain:
	move.l	(%0)+,(%%a1)+ ; move.l  (%0)+,(%%a1)+ ; move.l  (%0)+,(%%a1)+ ; move.l  (%0)+,(%%a1)+ ; move.l  (%0)+,(%%a1)
	lea		(14,%%a1),%%a1
	dbra	%%d0,restaure_terrain
	" :: "a" (tampon): "d0","a1") ;

	Boucle() ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void affiche_or(unsigned char **ptr, unsigned char val)
{
	if ((*ptr-(unsigned char*)0x4C08)%30 >= LargeurOctetsTerrain)	// Si a dpasse  droite du terrain, boucle  gauche
		*ptr -= LargeurOctetsTerrain ;

	**ptr |= val ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void affiche_xor(unsigned char **ptr, unsigned char val)
{
	if ((*ptr-(unsigned char*)0x4C08)%30 >= LargeurOctetsTerrain)	// Si a dpasse  droite du terrain, boucle  gauche
		*ptr -= LargeurOctetsTerrain ;

	**ptr ^= val ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void bitmap_put(short x, short y, unsigned char *pic, short mode)
{
	unsigned char *ptr = ((unsigned char*)0x4C00)+((y << 5)-(y << 1)+(x >> 3)) ;
	short hauteur = *(short*)pic, largeur = *(short*)(pic+2) ;
	short octets = largeur >> 3, saute = 30-octets+(x+largeur > Xmax ? LargeurOctetsTerrain : 0), reste = largeur&7 ;
	short decal1 = x&7, decal2, masque = (0xFF00 >> reste)&0xFF, loop ;

	pic += 4 ;
	if (decal1 != 0)
	{
		decal2 = 8-decal1 ;
		for (; hauteur-- ; ptr += saute)
		{
			if (ptr > (TailleTerrain == NORMAL ? (unsigned char*)0x577F : (unsigned char*)0x5AC7))
				ptr -= TailleTerrain == NORMAL ? 2880 : 3720 ;		// Si a dpasse en bas du terrain, boucle en haut
			if (mode == 1)
			{
				if (octets != 0)
				{
					*ptr++ |= *pic >> decal1 ;
					for (loop = octets ; --loop ;)
					{
						affiche_or(&ptr, (*pic++) << decal2) ;
						*ptr++ |= *pic >> decal1 ;
					}
					affiche_or(&ptr, *pic++ << decal2) ;
				}
				if (reste != 0)
				{
					*ptr |= ((*pic)&masque) >> decal1 ;
					if (decal1+reste > 7)
					{
						ptr++ ;
						affiche_or(&ptr, ((*pic)&masque) << (8-decal1)) ;
						ptr-- ;
					}
					pic++ ;
				}
			}
			else if (mode == 2)
			{
				if (octets != 0)
				{
					*ptr++ ^= *pic >> decal1 ;
					for (loop = octets ; --loop ;)
					{
						affiche_xor(&ptr, (*pic++) << decal2) ;
						*ptr++ ^= *pic >> decal1 ;
					}
					affiche_xor(&ptr, *pic++ << decal2) ;
				}
				if (reste != 0)
				{
					*ptr ^= ((*pic)&masque) >> decal1 ;
					if (decal1+reste > 7)
					{
						ptr++ ;
						affiche_xor(&ptr, ((*pic)&masque) << (8-decal1)) ;
						ptr-- ;
					}
					pic++ ;
				}
			}
			else if (mode == 4)
			{
				if (octets != 0)
				{
					*ptr &= ~(0xFF >> decal1) ;
					*ptr++ |= *pic >> decal1 ;
					for (loop = octets ; --loop ;)
					{
						if ((ptr-(unsigned char*)0x4C08)%30 >= LargeurOctetsTerrain)
							ptr -= LargeurOctetsTerrain ;
						*ptr = 0x00 ;
						*ptr |= (*pic++) << decal2 ;
						*ptr++ |= *pic >> decal1 ;
					}
					if ((ptr-(unsigned char*)0x4C08)%30 >= LargeurOctetsTerrain)
						ptr -= LargeurOctetsTerrain ;
					*ptr &= ~(0xFF << decal2) ;
					*ptr |= *pic++ << decal2 ;
				}
				if (reste != 0)
				{
					*ptr &= ~(masque >> decal1) ;
					*ptr |= ((*pic)&masque) >> decal1 ;
					if (decal1+reste > 7)
					{
						ptr++ ;
						if ((ptr-(unsigned char*)0x4C08)%30 >= LargeurOctetsTerrain)
							ptr -= LargeurOctetsTerrain ;
						*ptr &= ~(masque << (8-decal1)) ;
						*ptr-- |= ((*pic)&masque) << (8-decal1) ;
					}
					pic++ ;
				}
			}
		}
	}
	else
	{
		for (; hauteur-- ; ptr += saute)
		{
			if (ptr > (TailleTerrain == NORMAL ? (unsigned char*)0x577F : (unsigned char*)0x5AC7))
				ptr -= TailleTerrain == NORMAL ? 2880 : 3720 ;
			if (mode == 1)
			{
				for (loop = octets ; loop-- ; ptr++) affiche_or(&ptr, *pic++) ;
				if (reste != 0) affiche_or(&ptr, (*pic++)&masque) ;
			}
			else if (mode == 2)
			{
				for (loop = octets ; loop-- ; ptr++) affiche_xor(&ptr, *pic++) ;
				if (reste != 0) affiche_xor(&ptr, (*pic++)&masque) ;
			}
			else if (mode == 4)
			{
				for (loop = octets ; loop-- ; ptr++)
				{
					*ptr = 0x00 ;
					affiche_or(&ptr, *pic++) ;
				}
				if (reste != 0)
				{
					*ptr &= ~masque ;
					affiche_or(&ptr, (*pic++)&masque) ;
				}
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void nouveau(void)
{
	char *ptr, *tmp ;

	ClrTerrain() ;
	for (ptr = (TailleTerrain == NORMAL ? (char*)0x5026 : (char*)0x51CE) ; ptr <= (TailleTerrain == NORMAL ? (char*)0x538C : (char*)0x5534) ; ptr += 30)
		for (tmp = ptr ; tmp <= ptr+3 ; tmp++) *tmp = random(256) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_fond_intro(void)
{
	static unsigned char plan1[] = {0,100,0,160, 0x00,0x00,0x01,0xDF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x71,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xDC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x11,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x9C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x1E,0x00,0x00,0x00,0x00,0x00,0x00,0x79,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x8F,0x00,0x00,0x00,0x00,0x00,0x00,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC7,0x80,0x00,0x00,0x00,0x00,0x01,0xC7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x63,0xC0,0x00,0x00,0x00,0x00,0x01,0x8E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x31,0xE0,0x00,0x00,0x00,0x00,0x03,0x9C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0xE0,0x00,0x00,0x00,0x00,0x07,0x38,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x08,0xF0,0x00,0x00,0x00,0x00,0x0E,0x38,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x78,0x00,0x00,0x00,0x00,0x0E,0x70,0x00,0x00,0x00,0x00,0xF0,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x06,0x38,0x00,0x00,0x00,0x00,0x1C,0xE0,0x00,0x00,0x00,0x01,0xFF,0x08,0xE0,0x00,0x00,0x00,0x00,0x00,0x02,0x1C,0x00,0x00,0x00,0x00,0x3C,0xE0,0x00,0x00,0x00,0x01,0x8F,0x8C,0x60,0x00,0x00,0x00,0x00,0x00,0x03,0x1E,0x00,0x00,0x00,0x00,0x39,0xC0,0x00,0x00,0x00,0x01,0xC1,0x8C,0x30,0x00,0x0F,0x80,0x00,0x00,0x01,0x8E,0x00,0x00,0x00,0x00,0x7B,0x80,0x00,0x0F,0x80,0x3E,0xC1,0xFC,0x30,0x00,0x0F,0x80,0x00,0x00,0x00,0x87,0x00,0x00,0x00,0x00,0x73,0x80,0x00,0x31,0xC0,0x7A,0x00,0x1C,0x30,0x00,0x18,0xC0,0x00,0x00,0x00,0xC7,0x00,0x00,0x00,0x00,0xE7,0x00,0x00,0x20,0x60,0xE0,0x00,0x00,0x3C,0x00,0x30,0xC0,0x00,0x00,0x00,0x43,0x80,0x00,0x00,0x00,0xC7,0x00,0x00,0x38,0x31,0xC1,0xFF,0x00,0x3F,0x00,0x61,0xC0,0x00,0x00,0x00,0x63,0x80,0x00,0x00,0x01,0xCE,0x00,0x00,0x1E,0x3F,0x9F,0x83,0xE0,0xE3,0xE1,0xC1,0x80,0x00,0x38,0x00,0x21,0xC0,0x00,0x00,0x01,0xCE,0x00,0x00,0x03,0x1F,0x70,0x00,0x3F,0xE0,0x7F,0x83,0x80,0x00,0x7C,0x00,0x31,0xC0,0x00,0x00,0x03,0x9C,0x00,0x00,0x01,0x80,0xC0,0x78,0x00,0x1E,0x3E,0x06,0x00,0x03,0xFE,0x00,0x10,0xE0,0x00,0x00,0x03,0x1C,0x00,0x00,0x00,0x81,0x80,0xF8,0x00,0x02,0x00,0x0E,0x00,0x07,0xBF,0x00,0x18,0xE0,0x00,0x00,0x07,0x38,0x00,0x00,0x00,0xC3,0x00,0xF0,0x00,0x02,0x00,0x3C,0x00,0x06,0x0F,0x00,0x08,0x70,0x00,0x00,0x06,0x38,0x00,0x00,0x01,0x9E,0x00,0x00,0x00,0x03,0x00,0x78,0x00,0x06,0x0F,0x00,0x0C,0x70,0x00,0x00,0x06,0x70,0x00,0x00,0x07,0x20,0x00,0x00,0x01,0xC1,0xC1,0xE0,0x00,0x0E,0x07,0x00,0x04,0x70,0x00,0x00,0x0C,0x70,0x00,0x00,0x04,0x20,0x00,0x00,0x01,0xC0,0x43,0xC0,0x00,0x0E,0x07,0x80,0x06,0x38,0x00,0x00,0x0C,0x70,0x00,0x00,0x0C,0x60,0x07,0xFE,0x01,0x80,0x43,0x00,0x00,0x0E,0x03,0x80,0x06,0x38,0x00,0x00,0x0C,0xE0,0x00,0x1F,0x18,0xC1,0x1C,0xFF,0x80,0x00,0x43,0x00,0x00,0x06,0x03,0x80,0x02,0x38,0x00,0x00,0x18,0xE0,0x00,0x7F,0xD8,0x83,0x13,0xFF,0x80,0x00,0x63,0x80,0x00,0x07,0x07,0x80,0x03,0x1C,0x00,0x00,0x18,0xE0,0x00,0x66,0x71,0x63,0x3F,0xFF,0x40,0x00,0x21,0xC0,0x00,0x07,0x0F,0x00,0x03,0x1C,0x00,0x00,0x19,0xC0,0x00,0x7B,0x03,0xC2,0x6F,0xF9,0xF0,0x02,0x30,0xE0,0x00,0x03,0xFE,0x00,0x01,0x1C,0x00,0x00,0x19,0xC0,0x00,0x36,0x0F,0x02,0x7F,0xFF,0xB8,0x06,0x18,0x60,0x00,0x03,0xFC,0x00,0x01,0x1C,0x00,0x00,0x31,0xC0,0x00,0x03,0xBC,0x00,0xDD,0xFF,0xD8,0x34,0x0E,0x30,0x00,0x00,0xE0,0x00,0x01,0x0E,0x00,0x00,0x31,0xC0,0x00,0x00,0xF4,0xE0,0xDD,0xFF,0x98,0x35,0x03,0x38,0x00,0x00,0x00,0x00,0x01,0x8E,0x00,0x00,0x33,0x80,0x00,0x01,0xC9,0xC0,0xBF,0xFF,0x98,0x6E,0x01,0x18,0x00,0x00,0x00,0x00,0x00,0x8E,0x00,0x00,0x33,0x80,0x00,0x03,0x8B,0x81,0xFF,0x9F,0x70,0xCA,0x01,0x98,0x00,0x00,0x00,0x00,0x00,0x8E,0x00,0x00,0x33,0x80,0x00,0x03,0x1D,0xE3,0xFE,0xBF,0xE0,0x96,0x01,0x1C,0x00,0x00,0x00,0x00,0x00,0x8E,0x00,0x00,0x33,0x80,0x00,0x03,0x3F,0x87,0xF9,0xEF,0x80,0xB4,0x03,0x18,0x00,0x00,0x00,0x00,0x00,0x8F,0x00,0x00,0x73,0x80,0x00,0x3F,0xEE,0x0F,0xFF,0xBC,0x00,0x00,0x03,0x18,0x00,0x00,0x00,0x00,0x00,0xCF,0x00,0x00,0x73,0x00,0x00,0x77,0xF8,0x0F,0x7F,0xF0,0x00,0x00,0x01,0x18,0x00,0x00,0x07,0xC0,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0xC3,0x70,0x0E,0xDF,0xE0,0x00,0x00,0x01,0x18,0x00,0x00,0x3F,0xE0,0x00,0x47,0x00,0x00,0x73,0x00,0x00,0xC3,0xC0,0x0D,0xE7,0xC0,0x00,0x00,0x01,0x98,0x00,0x00,0x7F,0xE0,0x00,0x47,0x00,0x00,0x73,0x00,0x00,0xDF,0xC0,0x7C,0xCF,0xC0,0x00,0x00,0x01,0x98,0x00,0x00,0xFC,0xE0,0x00,0x47,0x00,0x00,0x73,0x00,0x01,0xF3,0xC4,0x78,0xFF,0xC0,0x00,0x00,0x00,0x18,0x00,0x01,0xC0,0xF0,0x00,0x47,0x00,0x00,0x73,0x00,0x00,0xE6,0xDC,0x6F,0xFF,0x78,0x00,0x00,0x00,0x38,0x00,0x01,0xC0,0x7C,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0x06,0x70,0xEF,0xFF,0xFF,0x80,0x00,0x00,0x30,0x00,0x01,0x80,0x7E,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0x06,0x40,0x0E,0x6F,0xF1,0x80,0x00,0x00,0x38,0x00,0x01,0x80,0x3E,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0x06,0xE4,0x06,0x7F,0x66,0xC0,0x00,0x00,0x3C,0x0C,0x01,0x80,0x06,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0x03,0x68,0x07,0xFD,0xFC,0xC0,0x00,0x00,0x0F,0xFE,0x03,0x80,0x06,0x00,0x4F,0x00,0x00,0x73,0x00,0x00,0x03,0x32,0x07,0x7F,0xDF,0xC0,0x00,0x00,0x37,0xFC,0x03,0x80,0x06,0x00,0x4F,0x00,0x00,0x73,0x00,0x02,0x01,0x32,0x06,0x33,0xFF,0xC0,0x00,0x00,0x30,0x38,0x03,0x00,0x06,0x00,0x4F,0x00,0x00,0x73,0x80,0x0F,0x19,0xB4,0x43,0xFF,0xEB,0x80,0x00,0x00,0x7C,0x70,0x03,0x00,0x06,0x00,0xCF,0x00,0x00,0x3B,0x80,0x0F,0x39,0xD5,0xC1,0xFF,0xFF,0x00,0x00,0x00,0x7F,0xE0,0x07,0x00,0x0E,0x00,0xCF,0x00,0x00,0x3B,0x80,0x0D,0xEC,0xD8,0xC0,0x03,0xF8,0x00,0x00,0x00,0x6F,0xC0,0x07,0x00,0x0E,0x00,0x8E,0x00,0x00,0x3B,0x80,0x0C,0xCD,0x88,0xC4,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x06,0x00,0x0E,0x00,0x9E,0x00,0x00,0x3B,0x80,0x0E,0x0F,0x9C,0x84,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x0E,0x00,0x1C,0x00,0x8E,0x00,0x00,0x39,0xC0,0x06,0x07,0x98,0x84,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0x0E,0x00,0x1C,0x01,0x8E,0x00,0x00,0x39,0xC0,0x06,0x79,0x19,0x86,0x18,0x80,0x00,0x00,0x01,0xC0,0x00,0x1C,0x00,0x38,0x01,0xAE,0x00,0x00,0x1D,0xC0,0x06,0x7C,0x19,0x8E,0x19,0xE0,0x00,0x00,0x03,0x80,0x00,0x3C,0x00,0x38,0x01,0x3C,0x00,0x00,0x1D,0xC0,0x06,0x6F,0x1D,0x0E,0x19,0xF0,0x00,0x00,0x03,0x80,0x00,0x78,0x00,0x70,0x01,0x3C,0x00,0x00,0x1C,0xE0,0x06,0x67,0xF5,0x0E,0x1B,0xE0,0x00,0x00,0x07,0x00,0x00,0xF0,0x00,0x70,0x02,0x3C,0x00,0x00,0x1E,0xE0,0x06,0x61,0xF7,0x0F,0xDB,0xC1,0x00,0x00,0x0E,0x00,0x00,0xE0,0x00,0xE0,0x02,0x3C,0x00,0x00,0x0E,0xE0,0x06,0x70,0xF7,0x05,0x18,0xC1,0x00,0x00,0x1C,0x00,0x00,0xE0,0x00,0xE0,0x00,0x78,0x00,0x00,0x0E,0x70,0x07,0xF8,0x73,0x84,0x18,0xC3,0x00,0x00,0x38,0x00,0x00,0xE0,0x01,0xC0,0x04,0x78,0x00,0x00,0x0E,0x70,0x01,0xFC,0x71,0xB6,0x28,0x43,0x00,0x00,0xF0,0x00,0x00,0xC0,0x03,0xC0,0x00,0x78,0x00,0x00,0x07,0x70,0x00,0x3C,0x31,0xF6,0x78,0x41,0x08,0x01,0xE0,0x00,0x01,0xC0,0x03,0x80,0x00,0x70,0x00,0x00,0x07,0x38,0x00,0x1C,0x39,0x12,0xFC,0x41,0x00,0x03,0xC0,0x00,0x01,0xC0,0x07,0x00,0x08,0x70,0x00,0x00,0x07,0xB8,0x00,0x00,0x1D,0x9B,0x9E,0x43,0xF4,0x07,0x00,0x00,0x01,0xC0,0x0F,0x00,0x00,0x70,0x00,0x00,0x03,0x9C,0x00,0x00,0x0F,0x8F,0x8B,0xFF,0xF4,0x0E,0x00,0x00,0x01,0xC0,0x1E,0x00,0x10,0xE0,0x00,0x00,0x03,0xDC,0x00,0x00,0x06,0x83,0x0C,0x41,0x86,0x1E,0x00,0x00,0x01,0xC0,0x3C,0x00,0x10,0xE0,0x00,0x00,0x01,0xCE,0x00,0x00,0x03,0x00,0x0C,0x61,0xC2,0x1C,0x00,0x00,0x00,0xE0,0x78,0x00,0x31,0xC0,0x00,0x00,0x01,0xCE,0x00,0x00,0x03,0xFC,0x04,0x60,0xC0,0x1C,0x00,0x00,0x00,0xE1,0xF0,0x00,0x21,0xC0,0x00,0x00,0x00,0xE7,0x00,0x00,0x00,0xFE,0x02,0x20,0x2F,0xDC,0x00,0x00,0x00,0xFF,0xE0,0x00,0xF3,0x80,0x00,0x00,0x00,0xE7,0x00,0x00,0x00,0x07,0x3F,0x90,0x3F,0xDC,0x00,0x00,0x00,0x7F,0x80,0x01,0xFB,0x80,0x00,0x00,0x00,0x73,0x80,0x00,0x00,0x03,0x7F,0xFF,0xF8,0xDC,0x00,0x00,0x00,0x3E,0x00,0x03,0xFF,0x00,0x00,0x00,0x00,0x7B,0x80,0x00,0x00,0x03,0x60,0xFF,0xE0,0xDC,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0x00,0x00,0x00,0x00,0x39,0xC0,0x00,0x00,0x03,0x60,0x00,0x00,0xCE,0x00,0x00,0x00,0x00,0x00,0x0F,0xFE,0x00,0x00,0x00,0x00,0x3C,0xE0,0x00,0x00,0x03,0x60,0x00,0x00,0xC7,0x00,0x00,0x00,0x00,0x00,0x1F,0xFE,0x00,0x00,0x00,0x00,0x1C,0xE0,0x00,0x00,0x01,0xE0,0x00,0x00,0xE7,0x00,0x00,0x00,0x00,0x00,0x3F,0xFC,0x00,0x00,0x00,0x00,0x0E,0x70,0x00,0x00,0x01,0xF0,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x3F,0xF8,0x00,0x00,0x00,0x00,0x0F,0x38,0x00,0x00,0x01,0xB8,0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x7F,0xF8,0x00,0x00,0x00,0x00,0x07,0xB8,0x00,0x00,0x01,0x9C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,0xF0,0x00,0x00,0x00,0x00,0x03,0x9C,0x00,0x00,0x01,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xFF,0xF0,0x00,0x00,0x00,0x00,0x01,0xCE,0x00,0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xE3,0xFC,0x00,0x00,0x00,0x00,0x01,0xE7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x81,0xFE,0x00,0x00,0x00,0x00,0x00,0xF3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x01,0xFE,0x00,0x00,0x00,0x00,0x00,0x79,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x01,0xFE,0x00,0x00,0x00,0x00,0x00,0x3C,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x07,0xFF,0x80,0x00,0x00,0x00,0x00,0x1E,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7C,0x0F,0xFF,0xE0,0x00,0x00,0x00,0x00,0x0F,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0x00,0x00,0xFC,0x3F,0xC7,0xF0,0x00,0x00,0x00,0x00,0x07,0x9E,0x00,0x00,0x00,0x00,0x00,0x0F,0xE0,0x00,0x00,0x01,0xFE,0xFF,0x87,0xF0,0x00,0x00,0x00,0x00,0x03,0xCF,0x00,0x00,0x00,0x00,0x00,0x38,0x60,0x00,0x00,0x03,0xFF,0xFF,0x03,0xF0,0x00,0x00,0x00,0x00,0x01,0xE3,0x80,0x00,0x00,0x0F,0xFF,0xC1,0xC0,0x00,0x00,0x03,0xFF,0xFF,0x07,0xF0,0x00,0x00,0x00,0x00,0x00,0xF9,0xC0,0x00,0x00,0x08,0x00,0x7F,0x00,0x00,0x00,0x0F,0xFF,0xFF,0x1F,0xF0,0x00,0x00,0x00,0x00,0x00,0x7C,0xE0,0x00,0x00,0x07,0xFF,0xF0,0x00,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xFF,0xC0,0x00,0x00,0x00,0x00,0x1E,0xF0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x00,0x00,0x00,0x00,0x0E,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xEF,0xFF,0xFF,0xFF,0xFF,0xFE,0x00} ;

	#ifdef _92
		ClrScr() ;
	#endif
	BitmapPut(_89_92(0,40), _89_92(0,14), plan1, &ECRAN, 4) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void disp_intro(void)
{
	static unsigned char plan0[] = {0,100,0,160, 0xFF,0xFF,0xFF,0xAF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xE0,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0xAF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0xF0,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x6E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x37,0x78,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFE,0xDC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1B,0xBC,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFD,0xB8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0D,0xDE,0x00,0x00,0x00,0x00,0xFF,0xFF,0xF8,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0xEF,0x00,0x00,0x00,0x00,0xFF,0xFF,0xB0,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x77,0x80,0x00,0x00,0x00,0xFF,0xFF,0x71,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xBB,0x00,0x00,0x00,0x00,0xFF,0xFE,0xE3,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xDF,0x80,0x00,0x00,0x00,0xFF,0xFF,0xC7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x6F,0xC0,0x00,0x00,0x00,0xFF,0xFF,0x8E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2F,0xF0,0x00,0x00,0x00,0xFF,0xFF,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0x70,0x00,0x00,0x00,0xFF,0xF6,0x1C,0x00,0x00,0x00,0x00,0x00,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x1B,0xB0,0x00,0x00,0x00,0xFF,0xFF,0x38,0x00,0x00,0x00,0x00,0xF0,0x0F,0xC0,0x00,0x00,0x00,0x00,0x00,0x0D,0xFC,0x00,0x00,0x00,0xFF,0xFF,0x70,0x00,0x00,0x00,0x01,0xFF,0x08,0xE0,0x00,0x00,0x00,0x00,0x00,0x05,0xFC,0x00,0x00,0x00,0xFF,0xDB,0x70,0x00,0x00,0x00,0x01,0x9F,0x88,0x60,0x00,0x00,0x00,0x00,0x00,0x06,0x8C,0x00,0x00,0x00,0xFF,0xFE,0xE0,0x00,0x00,0x00,0x00,0xC1,0x8C,0x20,0x00,0x0F,0x80,0x00,0x00,0x03,0x0F,0x00,0x00,0x00,0xFF,0xB5,0xC0,0x00,0x1F,0x00,0x3F,0xC1,0xFC,0x30,0x00,0x1F,0x80,0x00,0x00,0x01,0x46,0x00,0x00,0x00,0xFF,0xFD,0xC0,0x00,0x30,0xC0,0x7D,0xC0,0xFC,0x20,0x00,0x39,0xC0,0x00,0x00,0x01,0x83,0x80,0x00,0x00,0xFF,0xEB,0x80,0x00,0x20,0x60,0xC0,0x00,0x00,0x38,0x00,0x70,0xC0,0x00,0x00,0x00,0xE3,0x80,0x00,0x00,0xFF,0xCB,0x80,0x00,0x38,0x31,0xC0,0xFE,0x00,0x3F,0x80,0xE1,0xC0,0x01,0xF8,0x00,0xD1,0xC0,0x00,0x00,0xFF,0xC7,0x00,0x00,0x0E,0x1F,0x9E,0x01,0xE7,0x63,0xC1,0xC3,0x80,0x03,0xC4,0x00,0x71,0xC0,0x00,0x00,0xFF,0x97,0x00,0x00,0x03,0x0F,0x78,0x00,0x78,0x20,0xF7,0x87,0x00,0x07,0xFE,0x00,0x69,0xE0,0x00,0x00,0xFD,0x8E,0x00,0x00,0x01,0x80,0xC0,0x30,0x00,0x3E,0x1E,0x07,0x00,0x05,0xFE,0x00,0x38,0xE0,0x00,0x00,0xFF,0x2E,0x00,0x00,0x00,0x80,0x80,0xE8,0x00,0x0A,0x00,0x0E,0x00,0x0B,0x1E,0x00,0x34,0xF0,0x00,0x00,0xFB,0x1C,0x00,0x00,0x00,0x91,0x00,0xF8,0x00,0x03,0x00,0x1C,0x00,0x1F,0x06,0x00,0x1C,0xE0,0x00,0x00,0xFE,0x1C,0x00,0x00,0x01,0xBE,0x00,0x00,0x00,0x03,0x00,0x70,0x00,0x1F,0x07,0x80,0x18,0x70,0x00,0x00,0xFE,0x38,0x00,0x00,0x07,0x30,0x00,0x00,0x01,0xC1,0xC1,0xE0,0x00,0x15,0x0F,0x80,0x0A,0x38,0x00,0x00,0xF4,0xB8,0x00,0x00,0x04,0x20,0x00,0x00,0x01,0xC1,0xC3,0x80,0x00,0x15,0x03,0x00,0x0C,0x70,0x00,0x00,0xFE,0xB8,0x00,0x00,0x0C,0x60,0x0F,0xFE,0x03,0x80,0x63,0x00,0x00,0x17,0x07,0x00,0x0D,0x78,0x00,0x00,0xFD,0x70,0x00,0x0F,0x98,0xC0,0x1F,0xFF,0x80,0x80,0x43,0x80,0x00,0x1F,0x07,0x00,0x07,0x1C,0x00,0x00,0xED,0x70,0x00,0x33,0xF8,0x83,0x33,0xB3,0xC0,0x00,0x61,0x80,0x00,0x1A,0x03,0x00,0x06,0x38,0x00,0x00,0xF9,0x70,0x00,0x6E,0x79,0xE2,0x37,0x5F,0xC0,0x00,0x21,0xC0,0x00,0x1B,0x97,0x80,0x06,0xBC,0x00,0x00,0xF8,0xE0,0x00,0x7A,0x03,0x82,0x3F,0xFD,0xF0,0x04,0x30,0xE0,0x00,0x1F,0xFF,0x00,0x02,0x1E,0x00,0x00,0xF8,0xE0,0x00,0x07,0x0F,0x02,0x6F,0xFF,0xB0,0x06,0x0C,0x70,0x00,0x1D,0xFB,0x00,0x03,0x8E,0x00,0x00,0xD0,0xE0,0x00,0x03,0xFC,0x00,0x5D,0xFF,0xD8,0x14,0x06,0x70,0x00,0x0F,0x1E,0x00,0x03,0x9C,0x00,0x00,0xF0,0xE0,0x00,0x00,0xF8,0xE0,0xD5,0x7F,0x98,0x35,0x03,0x38,0x00,0x0F,0xFC,0x00,0x03,0x1E,0x00,0x00,0xF1,0xC0,0x00,0x01,0xC9,0xC0,0xFF,0xFF,0x98,0x6A,0x03,0x98,0x00,0x03,0xE0,0x00,0x01,0x1E,0x00,0x00,0xF1,0xC0,0x00,0x03,0x89,0x81,0xFF,0xDF,0x78,0x4A,0x01,0x1C,0x00,0x00,0x00,0x00,0x01,0x9F,0x00,0x00,0xF1,0xC0,0x00,0x03,0x0F,0xE3,0xFE,0x3F,0xE0,0x9E,0x01,0x18,0x00,0x00,0x00,0x00,0x01,0xCF,0x00,0x00,0xF1,0xC0,0x00,0x03,0x3F,0x87,0xFD,0xCF,0x01,0xB6,0x01,0x18,0x00,0x00,0x00,0x00,0x01,0xC6,0x00,0x00,0xB1,0xC0,0x00,0x3F,0xFC,0x05,0xFF,0xBE,0x00,0x00,0x01,0x18,0x00,0x00,0x00,0x00,0x01,0x86,0x00,0x00,0xB3,0x80,0x00,0x6F,0xF8,0x0F,0x7F,0x70,0x00,0x00,0x01,0x18,0x00,0x00,0x00,0x00,0x00,0x86,0x00,0x00,0xB3,0x80,0x00,0xC1,0x60,0x0F,0xEF,0x40,0x00,0x00,0x01,0x18,0x00,0x00,0x40,0x00,0x00,0x8F,0x00,0x00,0xF3,0x80,0x00,0xC3,0xC0,0x0F,0xC7,0xC0,0x00,0x00,0x01,0x98,0x00,0x00,0x80,0x00,0x00,0xCF,0x00,0x00,0xF3,0x80,0x01,0xDF,0xC0,0x39,0xCE,0xE0,0x00,0x00,0x00,0x98,0x00,0x00,0x03,0x00,0x00,0xCF,0x00,0x00,0xF3,0x80,0x01,0xBB,0xC0,0x6C,0xFF,0xE0,0x00,0x00,0x00,0x18,0x00,0x00,0x27,0x00,0x00,0xCF,0x00,0x00,0xF3,0x80,0x01,0xF6,0xDC,0x7F,0xFE,0x70,0x00,0x00,0x00,0x18,0x00,0x00,0x03,0x80,0x00,0xC7,0x00,0x00,0xF3,0x80,0x00,0x06,0x70,0x6B,0xFF,0xFF,0x00,0x00,0x00,0x38,0x00,0x00,0x41,0x80,0x00,0xC7,0x00,0x00,0xF3,0x80,0x00,0x06,0x60,0x4E,0x6F,0xF7,0xC0,0x00,0x00,0x38,0x00,0x00,0x40,0xC0,0x00,0xC7,0x00,0x00,0xF3,0x80,0x00,0x03,0xE4,0x0E,0x7F,0xE2,0xC0,0x00,0x00,0x3E,0x1E,0x02,0x40,0x78,0x00,0xC7,0x00,0x00,0xF3,0x80,0x00,0x03,0x28,0x07,0xF9,0xFE,0xC0,0x00,0x00,0x0F,0xFC,0x00,0x40,0x79,0x00,0xC7,0x00,0x00,0xB3,0x80,0x00,0x03,0x38,0x07,0xFF,0xFF,0x40,0x00,0x00,0x37,0xF8,0x00,0x40,0x79,0x00,0x87,0x00,0x00,0xB3,0x80,0x00,0x01,0xB2,0x06,0x23,0xFD,0xC0,0x00,0x00,0x70,0x38,0x04,0xC0,0x79,0x00,0x86,0x00,0x00,0xB1,0xC0,0x07,0x09,0xF2,0x43,0x83,0xFF,0x80,0x00,0x00,0x7A,0x70,0x04,0xC0,0x79,0x01,0x86,0x00,0x00,0xF1,0xC0,0x0F,0x3D,0xD5,0xC1,0xFF,0xFF,0x00,0x00,0x00,0x7F,0xF0,0x00,0xC0,0x71,0x01,0x8E,0x00,0x00,0xF1,0xC0,0x09,0xFD,0xDC,0xC0,0x07,0xFC,0x00,0x00,0x00,0x7F,0xC0,0x08,0x80,0x71,0x01,0xDF,0x00,0x00,0xFD,0xC0,0x0C,0xED,0x98,0xC4,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x19,0x80,0x71,0x01,0xCF,0x00,0x00,0xFD,0xC0,0x0C,0x0F,0x8C,0x84,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x31,0x00,0xE2,0x01,0x7E,0x00,0x00,0xFE,0xE0,0x06,0x07,0x18,0x84,0x00,0x00,0x00,0x00,0x01,0xC0,0x00,0x30,0x00,0xE2,0x03,0x7E,0x00,0x00,0xDE,0xE0,0x06,0x71,0x11,0x86,0x09,0x40,0x00,0x00,0x01,0xC0,0x00,0x60,0x00,0xC6,0x03,0x5C,0x00,0x00,0xFA,0xE0,0x06,0xFC,0x19,0x06,0x09,0xE0,0x00,0x00,0x01,0x80,0x00,0xC0,0x01,0xC6,0x03,0xCE,0x00,0x00,0xFE,0xE0,0x06,0x6F,0xB1,0x0E,0x09,0xF0,0x00,0x00,0x03,0x00,0x00,0x80,0x01,0x8C,0x02,0xDE,0x00,0x00,0xFF,0x70,0x06,0x67,0xBD,0x0E,0x09,0xF0,0x00,0x00,0x07,0x00,0x01,0x08,0x03,0x8C,0x06,0x5C,0x00,0x00,0xED,0x70,0x06,0x60,0xF5,0x06,0x89,0xE1,0x00,0x00,0x0F,0x00,0x01,0x10,0x03,0x1C,0x06,0x18,0x00,0x00,0xFF,0x70,0x06,0x70,0xF7,0x07,0x08,0xC1,0x00,0x00,0x1E,0x00,0x03,0x10,0x07,0x18,0x04,0x3C,0x00,0x00,0xFF,0xB8,0x03,0xF8,0xF1,0x86,0x08,0x41,0x00,0x00,0x3C,0x00,0x03,0x00,0x06,0x38,0x0C,0x38,0x00,0x00,0xF7,0xB8,0x00,0xFC,0x71,0xE6,0x48,0x43,0x00,0x00,0xF8,0x00,0x03,0x20,0x0C,0x30,0x0C,0x30,0x00,0x00,0xFF,0xB8,0x00,0x3E,0x71,0xF2,0x68,0x41,0x08,0x01,0xF0,0x00,0x02,0x20,0x1C,0x70,0x08,0x78,0x00,0x00,0xFF,0xDC,0x00,0x1E,0x39,0x1A,0xBC,0x41,0x08,0x03,0x80,0x00,0x02,0x20,0x38,0xE0,0x10,0x70,0x00,0x00,0xFB,0x5C,0x00,0x08,0x1D,0x1F,0x8F,0xC3,0x40,0x03,0x80,0x00,0x02,0x30,0x70,0xC0,0x10,0xE0,0x00,0x00,0xFF,0xEE,0x00,0x00,0x0D,0x8F,0x8F,0xFF,0xE4,0x0F,0x00,0x00,0x02,0x30,0xE1,0x80,0x30,0xF0,0x00,0x00,0xFD,0xAE,0x00,0x00,0x06,0x81,0x08,0x61,0x82,0x1C,0x00,0x00,0x02,0x3F,0xC3,0x00,0x39,0xE0,0x00,0x00,0xFF,0xF7,0x00,0x00,0x07,0x80,0x0C,0x61,0x82,0x18,0x00,0x00,0x03,0x1F,0x86,0x00,0x61,0xE0,0x00,0x00,0xFF,0xF7,0x00,0x00,0x01,0xFC,0x04,0x60,0xC3,0x9C,0x00,0x00,0x03,0x1E,0x0C,0x00,0x73,0xC0,0x00,0x00,0xFF,0xFB,0x80,0x00,0x01,0xFE,0x1E,0x30,0x67,0xDC,0x00,0x00,0x01,0x00,0x18,0x00,0xEF,0xC0,0x00,0x00,0xFF,0xFB,0x80,0x00,0x00,0x03,0x3F,0xA0,0x3F,0xDC,0x00,0x00,0x00,0x80,0x70,0x01,0xF7,0x80,0x00,0x00,0xFF,0xFD,0xC0,0x00,0x00,0x03,0x73,0xFF,0xF1,0x9C,0x00,0x00,0x00,0x41,0xE0,0x03,0xFF,0x80,0x00,0x00,0xFF,0xB5,0xC0,0x00,0x00,0x03,0x60,0xFF,0xC1,0x9E,0x00,0x00,0x00,0x3F,0x80,0x07,0xFE,0x00,0x00,0x00,0xFF,0xFE,0xE0,0x00,0x00,0x03,0x60,0x00,0x01,0xCF,0x00,0x00,0x00,0x0E,0x00,0x0F,0xFF,0x00,0x00,0x00,0xFF,0xDB,0x70,0x00,0x00,0x03,0xE0,0x00,0x00,0xCF,0x00,0x00,0x00,0x00,0x00,0x1F,0xFC,0x00,0x00,0x00,0xFF,0xFF,0x70,0x00,0x00,0x01,0xE0,0x00,0x00,0xC7,0x00,0x00,0x00,0x00,0x00,0x1F,0xFC,0x00,0x00,0x00,0xFF,0xFF,0xB8,0x00,0x00,0x01,0xB0,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x3F,0xFC,0x00,0x00,0x00,0xFF,0xF6,0xDC,0x00,0x00,0x03,0xB8,0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0xFF,0xF0,0x00,0x00,0x00,0xFF,0xFF,0x5C,0x00,0x00,0x01,0x9C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0xFF,0xF0,0x00,0x00,0x00,0xFF,0xFF,0xEE,0x00,0x00,0x01,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xFF,0xF0,0x00,0x00,0x00,0xFF,0xFF,0xF7,0x00,0x00,0x00,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xDD,0xFC,0x00,0x00,0x00,0xFF,0xFE,0xFB,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0xFF,0xFE,0x00,0x00,0x00,0xFF,0xFF,0x6D,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x83,0xFE,0x00,0x00,0x00,0xFF,0xFF,0xB6,0xE0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7D,0x07,0xFF,0x00,0x00,0x00,0xFF,0xFF,0xFB,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x7B,0x0B,0xFE,0x40,0x00,0x00,0xFF,0xFF,0xFD,0xBC,0x00,0x00,0x00,0x00,0x00,0x07,0x80,0x00,0x00,0x00,0xFB,0xB7,0xFF,0xC0,0x00,0x00,0xFF,0xFF,0xFE,0xDE,0x00,0x00,0x00,0x00,0x00,0xFD,0xE0,0x00,0x00,0x00,0x7B,0xDF,0xE7,0xF0,0x00,0x00,0xFF,0xFF,0xFF,0x6F,0x00,0x00,0x00,0x1F,0x1F,0xF7,0xC0,0x00,0x00,0x00,0xFD,0x7F,0x43,0xF8,0x00,0x00,0xFF,0xFF,0xFF,0xF3,0x80,0x00,0x00,0x3F,0xFF,0x78,0xD0,0x00,0x00,0x01,0xFF,0xFF,0xDF,0xF8,0x00,0x00,0xFF,0xFF,0xFE,0xFD,0xC0,0x00,0x00,0x3F,0xFF,0x81,0xF0,0x00,0x00,0x03,0xFF,0xFE,0xFF,0xF8,0x00,0x00,0xFF,0xFF,0xFF,0x76,0xE0,0x00,0x00,0x3C,0x00,0x0E,0xF0,0x00,0x00,0x1F,0xFF,0xFF,0xEF,0xF8,0x00,0x00,0xFF,0xFF,0xFF,0xBB,0x70,0x00,0x00,0x3B,0xFF,0xFF,0xE0,0x00,0x00,0x3F,0xFF,0xFF,0xFF,0xF8,0x20,0x00,0xFF,0xFF,0xFF,0xFD,0x60,0x00,0x00,0x3F,0xFF,0xFF,0x80,0x00,0x00,0x77,0xFF,0xFF,0xFF,0xFF,0xFC,0x00,0xFF,0xFF,0xFF,0xFD,0x7C,0x00,0x00,0x0F,0xFF,0xFC,0x00,0x00,0x01,0xEF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00} ;

	GrayOn() ;
	SetPlane(0) ;
	#ifdef _92
		ClrScr() ;
	#endif
	BitmapPut(_89_92(0,40), _89_92(0,14), plan0, &ECRAN, 4) ;
	SetPlane(1) ;
	draw_fond_intro() ;
	attend_touche(RIEN_FAIRE) ;
	GrayOff() ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void disp_apropos(void)
{
	LCD_BUFFER lcd ;
	char bmp[3844] ;

	baisse_contraste(0) ;
	LCD_save(lcd) ;
	ClrScr() ;
	FontSetSys(2) ;
	DrawStr(_89_92(4,44), _89_92(2,16), PUT_VERSION(Jeu de la Vie v), 4) ;
	FontSetSys(1) ;
	DrawStr(_89_92(fr_eng(21,24),61), _89_92(20,34), fr_eng("par Franois Leiber", "by Franois Leiber"), 4) ;
	DrawStr(_89_92(34,74), _89_92(33,47), "leiber.free.fr", 4) ;
	draw_str_petit(_89_92(4,44), _89_92(50,64), fr_eng("Remerciements  :", "Credits:")) ;
	draw_str_petit(_89_92(7,47), _89_92(60,74), fr_eng("- L'quipe TI-GCC, part. Zeljko Juric", "- TI-GCC Team and Zeljko Juric")) ;
	draw_str_petit(_89_92(7,47), _89_92(68,82), fr_eng("- Johan G. Bontes pour Life32", "- Johan G. Bontes for Life32")) ;
	draw_str_petit(_89_92(7,47), _89_92(76,90), fr_eng("- Alan Hensel pour sa collection de motifs", "- Alan Hensel for his pattern collection")) ;
	draw_str_petit(_89_92(7,47), _89_92(84,98), fr_eng("- TATMF pour son image d'introduction", "- TATMF for the introduction picture")) ;
	draw_str_petit(_89_92(7,47), _89_92(92,106), fr_eng("- Ha ha ha pour T&T...", "- Ha ha ha for T&T...")) ;
	BitmapGet(&(SCR_RECT){{_89_92(0,40),_89_92(0,14),_89_92(159,199),_89_92(99,113)}}, bmp) ;
	OSSetSR(0x0000) ;
	GrayOn() ;
	SetPlane(0) ;
	draw_fond_intro() ;
	BitmapPut(_89_92(0,40), _89_92(0,14), bmp, &ECRAN, 1) ;
	BitmapPut(_89_92(1,41), _89_92(1,15), bmp, &ECRAN, 1) ;
	SetPlane(1) ;
	BitmapPut(_89_92(0,40), _89_92(0,14), bmp, &ECRAN, 4) ;
	restaure_contraste() ;
	FontSetSys(0) ;
	attend_touche(RIEN_FAIRE) ;
	GrayOff() ;
	OSSetSR(0x0700) ;
	LCD_restore(lcd) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void draw_interface(void)
{
	static unsigned char titre[] = {0,47,0,41, 0x03,0xFC,0x00,0x00,0x00,0x00,0x07,0xFE,0x00,0x00,0x00,0x00,0x03,0xFC,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00,0x00,0x70,0x0F,0x82,0x08,0x00,0x00,0x70,0x3F,0xC7,0x1C,0x00,0x00,0x70,0x7F,0xE7,0x1C,0x00,0x00,0x70,0x70,0xE7,0x1C,0x00,0x00,0x70,0xF3,0xE7,0x1C,0x00,0x10,0xF0,0xEF,0xC7,0x1C,0x00,0x38,0xF0,0xFF,0x07,0x1C,0x00,0x38,0xE0,0xFC,0x07,0x1C,0x00,0x3C,0xE0,0xF0,0xE7,0x1C,0x00,0x1F,0xE0,0x7F,0xE7,0xFC,0x00,0x0F,0xE0,0x3F,0xC3,0xFC,0x00,0x03,0xC0,0x1F,0x81,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x60,0x00,0x00,0x00,0x0C,0x00,0x60,0x00,0x00,0x00,0x7C,0xF0,0x67,0x00,0x00,0x00,0xCD,0x98,0x69,0x80,0x00,0x00,0xCD,0xF8,0x67,0x80,0x00,0x00,0xCD,0x80,0x6D,0x80,0x00,0x00,0xCD,0x98,0x6D,0x80,0x00,0x00,0x7C,0xF0,0x67,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x3D,0xFF,0x9F,0xFF,0x00,0xCF,0xFD,0xE3,0xCF,0x9F,0x00,0x7F,0x7C,0xFF,0x07,0x9E,0x00,0xFC,0x3C,0xFF,0x07,0xF8,0x00,0x78,0x38,0x0F,0x07,0xE0,0x00,0x3C,0x38,0x0F,0x07,0xF8,0x00,0x3C,0x38,0x0F,0x07,0xFC,0x00,0x1E,0x70,0x0F,0x07,0xD8,0x00,0x1E,0x70,0x0F,0x07,0x80,0x00,0x0E,0x60,0x0F,0x07,0x80,0x00,0x0F,0xE0,0x6F,0x07,0x80,0x00,0x07,0xC1,0xEF,0x07,0x83,0x00,0x07,0x81,0xFF,0x87,0xFF,0x80,0x07,0x81,0xFF,0x8F,0xFF,0x00,0x03,0x00,0xFF,0x1F,0xFF,0x00};

	clr_interface() ;
	BitmapPut(8, 6, titre, &ECRAN, 4) ;
	draw_str_petit(fr_eng(6,8), 62, fr_eng(PUT_VERSION(par FL - v), PUT_VERSION(by FL - v))) ;
	DrawClipRect(&(WIN_RECT){0, 73, 59, 92}, &ECRAN, 33) ;
	draw_str_petit(12, 95, "ON: Menu") ;
	draw_str_petit(29-(str_petit_largeur(Regle)>>1), 77, Regle) ;
	draw_str_petit(12, 84, "gen:") ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_menu(void)
{
	clr_interface() ;
	draw_str_petit(7, 6, fr_eng("Reprendre", "Resume")) ;
	draw_str_petit(7, 14, fr_eng("Editer", "Edit")) ;
	draw_str_petit(7, 22, fr_eng("Rgles", "Rules")) ;
	draw_str_petit(7, 30, "Options") ;
	draw_str_petit(7, 38, fr_eng("Sauver", "Save")) ;
	draw_str_petit(7, 46, fr_eng("A propos", "About")) ;
	draw_str_petit(7, 54, fr_eng("Quitter", "Quit")) ;
	DrawLine(7, 64, 45, 64, 4) ;
	draw_str_petit(7, 70, fr_eng("F1: Nouveau", "F1: New")) ;
	draw_str_petit(7, 78, fr_eng("F2: Avancer", "F2: Step")) ;
	draw_str_petit(7, 86, fr_eng("F3: Restaurer", "F3: Restore")) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_menu_edit(void)
{
	clr_interface() ;
	draw_str_petit(3, 6, "2ND: Point ON") ;
	draw_str_petit(3, 14, "SHIFT: Point OFF") ;
	draw_str_petit(3, 22, fr_eng("CLR: Efface", "CLR: Clear")) ;
	draw_str_petit(3, 30, "+curs: Scroll") ;
	DrawLine(3, 40, 56, 40, 4) ;
	draw_str_petit(3, 46, fr_eng("F1: Nouveau", "F1: New")) ;
	draw_str_petit(3, 54, fr_eng("F2: Avancer", "F2: Step")) ;
	draw_str_petit(3, 62, fr_eng("F3: Restaurer", "F3: Restore")) ;
	draw_str_petit(3, 70, fr_eng("F4: Motifs", "F4: Patterns")) ;
	draw_str_petit(3, 78, fr_eng("F5: Charger pic", "F5: Load pic")) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void draw_menu_rect(void)
{
	clr_interface() ;
	draw_str_petit(3, 6, fr_eng("Sauver sous", "Save as a")) ;
	draw_str_petit(3, 14, fr_eng("forme d'image:", "picture:")) ;
	draw_str_petit(3, 28, fr_eng("1er coin ?", "1st corner?")) ;
	DrawLine(3, 42, 47, 42, 4) ;
	draw_str_petit(3, 49, fr_eng("F1: Tout slect", "F1: Select all")) ;
	draw_str_petit(3, 57, "ENTER: OK") ;
	draw_str_petit(3, 65, fr_eng("ESC: Annuler", "ESC: Cancel")) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void draw_menu_pose(void)
{
	clr_interface() ;
	draw_str_petit(3, 6, fr_eng("Pour changer", "To change")) ;
	draw_str_petit(3, 14, fr_eng("le mode", "the display")) ;
	draw_str_petit(3, 22, fr_eng("d'affichage:", "mode:")) ;
	DrawLine(3, 34, 47, 34, 4) ;
	draw_str_petit(3, 42, "F1: Normal") ;
	draw_str_petit(3, 50, fr_eng("F2: Remplace", "F2: Replace")) ;
	draw_str_petit(3, 58, "F3: Inverse") ;
	draw_str_petit(3, 80, fr_eng("ENTER: Coller", "ENTER: Paste")) ;
	draw_str_petit(3, 88, fr_eng("ESC: Quitter", "ESC: Quit")) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void draw_menu_options(void)
{
	char str[] = fr_eng("   : Modifier", "  : Change") ;

	str[0] = 17 ; str[1] = 18 ;
	clr_interface() ;
	draw_str_petit(7, 6, fr_eng("Taille :", "Size:")) ;
	draw_str_petit(7, 14, fr_eng("Vitesse :", "Speed:")) ;
	DrawLine(7, 34, 47, 34, 4) ;
	draw_str_petit(7, 42, str) ;
	draw_str_petit(7, 50, fr_eng("+/- : Contraste", "+/-: Contrast")) ;
}
