/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


INT_HANDLER Ancien1 = NULL, Ancien5 = NULL ;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Redirige les interruptions 1, 4 et 5 vers rien en sauvegardant les prcdentes
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void init_int(void)
{
	Ancien1 = GetIntVec(AUTO_INT_1) ;
	Ancien5 = GetIntVec(AUTO_INT_5) ;
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER) ;
	SetIntVec(AUTO_INT_5, DUMMY_HANDLER) ;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Restaure les interruptions qui avaient t modifies
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void restaure_int(void)
{
	SetIntVec(AUTO_INT_1, Ancien1) ;
	SetIntVec(AUTO_INT_5, Ancien5) ;
	OSTimerRestart(2) ;
}
