/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


#define NBRE_REGLES 18

char Regle[] = "23/3\0               " ;

char *Regles[] = {"Perso", "/2", "/234", "12345/3", "125/36", "1357/1357", "1358/357", "23/3", "23/36", "235678/3678", "235678/378", "238/357",
	"245/368", "34/34", "34678/3678", "45678/3", "5/345", "5678/35678" } ;

char *TitreRegles[] = {
	fr_eng("Rgle personnalise", "Personalized rule"),
	"Phoenix, minimal",
	fr_eng("Phoenix, motifs de dentelle", "Phoenix, lacey patterns"),
	fr_eng("Formes en labyrinthes", "Maze-like designs"),
	"Life-like 2x2 block rule",
	fr_eng("Tout se rplique", "Everything is a replicator"),
	fr_eng("Rgle amibienne quilibre", "Balanced amoeba rule"),
	"\"Conway's Life\"",
	"\"HighLife\"",
	fr_eng("Tche d'encre, schant vite", "Ink blot, quick drying"),
	fr_eng("Coagulations chaotiques", "Coagulations in chaos"),
	fr_eng("Vie brise", "Broken Life"),
	fr_eng("Mort, vaisseaux & fusils", "Death plus puffers and ships"),
	"\"34 Life\"",
	fr_eng("\"Jour & Nuit\"" ,"\"Day & Night\""),
	fr_eng("Lente croissance en corail", "Slow coral growth"),
	fr_eng("\"Longue vie\"", "\"Long life\""),
	fr_eng("Diamants & catastrophes", "Diamonds & catastrophes") } ;

char *CaractRegles[] = {
	fr_eng("Totale libert", "Total Freedom"),
	fr_eng("(Explosant)", "(Exploding)"),
	fr_eng("(Explosant)", "(Exploding)"),
	fr_eng("(Explosant)", "(Exploding)"),
	fr_eng("(Chaotique)", "(Chaotic)"),
	fr_eng("(Explosant)", "(Exploding)"),
	fr_eng("(Chaotique)", "(Chaotic)"),
	fr_eng("(Chaotique)", "(Chaotic)"),
	fr_eng("(Chaotique)", "(Chaotic)"),
	"(Stable)",
	fr_eng("(Explosant)", "(Exploding)"),
	fr_eng("(Chaotique)", "(Chaotic)"),
	"(Stable)",
	fr_eng("(Explosant)", "(Exploding)"),
	"(Stable)",
	fr_eng("(Explosant)", "(Exploding)"),
	"(Stable)",
	fr_eng("(Chaotique)", "(Chaotic)") } ;

char *InfoRegles[] = {
	fr_eng("Tapez ENTER pour entrer une rgle personnalise, la calculatrice vous demandera d'entrer une chane de caractres. La premire partie, suivie d'un /, correspond aux cas o une cellule survit; la deuxime partie indique quand une cellule doit natre.",
		"Press ENTER to enter a personalized rule, the calculator will ask you to enter a string. The first part, followed by a /, corresponds to when the cell survives; the second part indicates when a cell must be born."),
	fr_eng("Chaque cellule meurt  chaque gnration, mais la plupart des motifs explosent tout de mme. C'est un dfi de crer des motifs qui n'explosent pas. Probablement la rgle avec dfi la plus simple.",
		"Every living cell dies every generation, but most patterns explode anyway. It's a challenge to build new patterns that don't explode. Arguably the simplest challenging rule."),
	fr_eng("Comme /2, chaque cellule meurt  chaque gnration. Mais cette rgle est choisie pour l'exceptionnelle beaut des motifs produits, comme s'ils taient tisss.",
		"Like /2, every living cell dies every generation. This rule is picked for the exceptional fabric-like beauty of the patterns that it produces."),
	fr_eng("Cristallise en des motifs ressemblant  des labyrinthes. Variation intressante : essayez de retirer le 5 dans les rgles de survie. Pour produire des souris courant dans le labyrinthe, ajoutez 7 aux rgles des naissances.",
		"An 'a-maze-ing' universe - crystalizes into maze-like patterns. Interesting variations: try removing 5 from the 'No change' list. To produce mice running in the maze, add 7 to the 'Births' list."),
	fr_eng("Assez semblable  la rgle de Conway, avec des motifs diffrents. Beaucoup d'oscillateurs apparaissent alatoirement, ainsi qu'un vaisseau rare. Cette rgle est aussi un univers de blocs 2x2 : c'est  dire qu'un motif uniquement constitu de blocs 2x2 aligns le restera.",
		"Similar in character to Conway's Life, but different patterns. Many oscillators occur at random, and a rare glider. This rule is also a 2x2 block universe. This means that patterns consisting entirely of 2x2 blocks, all aligned, will continue to consist of 2x2 blocks."),
	fr_eng("Dans cet univers remarquable chaque motif se rplique. Vous pouvez dessiner n'importe quelle image, vous la retrouverez multiplie en motifs aprs aprs un certain nombre de gnrations. Tout simplement gnial !",
		"In this remarkable universe every pattern is a replicator. I particularly like drawing my kid brother in gen=0 and then skipping +1024 gens."),
	fr_eng("Un univers qui forme de large zone alatoire qui ressemblent  des 'amibes'. L'intrieur des ces zones est chaotique. Les bords oscillent, et les motifs ont plutt tendance  grandir. Plus ils grandissent, plus ils ont de chance de survivre. C'est une rgle assez quilibre.",
		"An 'amoeba' universe - forms large random areas that resemble amoebas. Internal to a random area is chaos. The edge vascillates wildly, and patterns tend to grow more than shrink. The more they grow, the more certain their survival. This is a fairly well-balanced rule."),
	fr_eng("La rgle par dfaut, propose par Conway. L'automate cellulaire le plus connu. Des motifs ont t trouvs et tudis depuis environ 1970, de larges collections sont trouvables sur Internet.",
		"The default rule, proposed by Conway. This is the most famous cellular automata ever invented. People have been discovering patterns for this rule since around 1970. Large collections are available on the Internet."),
	fr_eng("Cette rgle ressemble beaucoup  celle de Conway, mais a un motif rplicant surprenant. Il n'y a aucun rplicant connu dans la rgle de Conway.",
		"This rule is very similar to Conway's Life, but is has a surprise replicator pattern. There is no known replicator in Conway's Life."),
	fr_eng("La plupart des variations de cette rgle sont croissantes  l'infini, mais celle-l non, tonnament. Pourquoi ?",
		"Most close variations of these rules expand forever, but this one curiously does not. Why?"),
	fr_eng("Cree des coagulation gluantes lors de son extension  l'infini. C'est une variation de la rgle prcdente, 235678/3678, except qu'il y a une condition de moins pour les naissances. Gnralement cela donne un univers moins actif, mais ici c'est une exception.",
		"Creates gooey coagulations as it expands forever. This is a close variation of the previous rule, 235678/3678, except that there is one less condition for a dead cell to come to life on the next generation. In general this should make a universe less active, but this is an exception."),
	fr_eng("Dans cette variation proche de la rgle de Conway, le chaos y est trs ressemblant, mais quasiment aucun des motifs habituels ne fonctionne.",
		"In this close variation of Conway's Life, the chaos is remarkably similar, but almost none of the engineered patterns work."),
	fr_eng("Un univers trs calme, qui a pourtant un vaisseau lent et un fusil lent trs communs.",
		"A very calm universe, which nonetheless has a very commonly occuring slow spaceship and a slow puffer."),
	fr_eng("Une des premires rgles alternatives tudie, ds les annes 1970. Les capacits de calcul taient si limits qu'il fallut des mois avant qu'on remarque que c'tait un univers explosant. Ce qui le rend intressant, c'est la varit de petits oscillateurs et le vaisseau de priode 3.",
		"One of the first explored alternatives to Conway's Life, in the early 1970's. Computing power was so low, it was months before anyone noticed that this is an exploding universe. What makes this universe interesting is the variety of small oscillators and the period-3 spaceship."),
	fr_eng("Appele ainsi parce que les cellules mortes au milieu de vivantes ont les mmes lois que l'inverse. Il y a manifestement d'autres rgles qui ont la mme proprit de symtrie, mais celle-ci a t choisie parce qu'elle a des vaisseaux et oscillateurs  grand priode intressants.",
		"So named because dead cells in fields of live cells act by the same rules as live cells in fields of dead cells. There are obviously other rules which have this symmetrical property, but this rule was chosen because it has some interesting high period spaceships and oscillators."),
	fr_eng("Cette rgle produit des motifs avec une vitesse de croissance tonnament lente, avec une intressante texture en corail.",
		"This rule produces patterns with a surprisingly slow rate of expansion and an interesting coral-like texture."),
	fr_eng("Appele ainsi  cause de ses motifs avec une priode extrmement longue que l'on peut construire dans cet univers.",
		"This rule is called 'Long life' because of the extremely high period patterns that can be produced in this universe."),
	fr_eng("Cre des 'amibes' en forme de diamants, tonnament imprdictibles. On ne sait toujours pas si certains diamants croissent  l'infini, ou si la tendance  l'auto-destruction des coins est trop forte.",
		"Creates solid diamond-shaped 'amoeba' patterns that are surprisingly unpredictable. It is not known whether any diamonds expand forever, or if the tendency toward the catastrophic destruction of corners is too strong.") } ;
