/**************************************************************************
 *
 *  Copyright (C) 2001-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Jeu de la Vie.
 *
 *	Jeu de la Vie is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Jeu de la Vie is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


////////////////////////////////////////////////////////////////////////////////////////////////////////

static inline void init_alphabet(void)
{
	short i ;

	FontSetSys(0) ;
	Alphabet = malloc(1280) ;
	memset(Alphabet, 0, 1280);
	LargeurLettre = malloc(512) ;
	memset(LargeurLettre, 0, 512);
	PortSet(Alphabet, 7, 1279);

	for (i = 0 ; i < 256 ; i++)
	{
		LargeurLettre[i] = FontCharWidth(i) ;
		DrawChar(0, 5*i, i, 4) ;
	}
	PortRestore() ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_str_petit(short x, short y, unsigned char *str)
{
	long ptr ;
	short i, decal ;
	unsigned char *lettre ;

	while (*str != 0)
	{
		lettre = Alphabet+5*(*str) ;
		ptr = (long)0x4C00+30*y+((x >> 3)&0xFFFE) ;
		decal = 24-(x&15) ;

		for(i = 5 ; i-- ; ptr += 30) *(long*)ptr |= (long)(*lettre++) << decal ;

		x += LargeurLettre[*str++];
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

short str_petit_largeur(unsigned char *str)
{
	short largeur = 0 ;

	while (*str != 0) largeur += LargeurLettre[*str++];

	return largeur ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_str_terrain(char *texte, short y)
{
	char tampon[90] ;
	short n, fin = 0 ;

	do
	{
		memset(tampon, 0, 90) ; *tampon = *texte ;
		n = 0 ;
		while (texte[n] != 0 && str_petit_largeur(tampon) <= LargeurTerrain) tampon[++n] = texte[n] ;
		if (tampon[n] != 0)
			while (tampon[n] != ' ') n-- ;
		else
			fin = 1 ;
		tampon[n] = 0 ;
		draw_str_petit(MilieuTerrainX-((str_petit_largeur(tampon))>>1), y, tampon) ;
		y += 7 ; texte += n+1 ;
	} while (fin == 0) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void draw_str(short x, short y, char* str)
{
	SetPlane(1) ;
	DrawStr(_89_92(x,x+40), _89_92(y,y+14), str, 1) ;
	SetPlane(0) ;
//	DrawStr(_89_92(x+1,x+41), _89_92(y+1,y+15), str, 1) ;
	DrawStr(_89_92(x,x+40), _89_92(y,y+14), str, 1) ;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void __attribute__((__stkparm__)) __my_sprintf__(unsigned char *str, unsigned short val) ;

asm("
__my_sprintf__:
        movem.l  %d0-%d3/%a0-%a1,-(%sp)
        lea      -6(%sp),%sp
        movea.l  %sp,%a0
        moveq    #0x30,%d1
        movea.l  34(%sp),%a1
        move.w   38(%sp),%d2
        cmpi.w   #9,%d2
        bhi.s    __my_sprintf_loop__
___my_sprintf_prepare_copy__:
        add.b    %d1,%d2
        move.b   %d2,(%a1)+
        bra.s    __my_sprintf_cleanup_and_bye__

__my_sprintf_loop__:
        divu.w   #10,%d2
        swap     %d2
        beq.s    __my_sprintf_prepare_copy__
        move.w   %d2,%d3
        add.b    %d1,%d3
        move.b   %d3,(%a0)+
        clr.w    %d2
        swap     %d2
        bra.s    __my_sprintf_loop__
__my_sprintf_prepare_copy__:
        move.l   %a0,%d0
        sub.l    %sp,%d0
        subq.b   #1,%d0
__my_sprintf_copy__:
        move.b   -(%a0),(%a1)+
        dbf      %d0,__my_sprintf_copy__
__my_sprintf_cleanup_and_bye__:
        clr.b    (%a1)
        lea      6(%sp),%sp
        movem.l  (%sp)+,%d0-%d3/%a0-%a1
        rts");
